/*
 * Declarations, includes and data types header
 * File name: incl.h
 * Author: Jaime Prez Crespo <japecre@lsub.org>
 * Last modification: May 10, 2004
 *
 * Copyright (c) 2004, Jaime Prez Crespo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * - Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice, this list
 *   of conditions and the following disclaimer in the documentation and/or other materials
 *   provided with the distribution.
 * - Neither the name of the Rey Juan Carlos University nor the names of its contributors
 *   may be used to endorse or promote products derived from this software without specific
 *   prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef __INCL_H
#define __INCL_H

#define _USE_GNU
#define _GNU_SOURCE
/* system calls and includes */
#include <sys/types.h>        /* basic system types */
#include <sys/socket.h>       /* system sockets */
#include <sys/time.h>         /* gettimeofday() */
#include <errno.h>            /* for errors on system calls */
#include <stdio.h>            /* basic input/output */
#include <netinet/in.h>       /* Internet definitions */
#include <arpa/inet.h>        /* inet_ntoa() to format IP address */
#include <sys/stat.h>         /* file mode constants */
#include <unistd.h>           /* required by stat */
#include <stdlib.h>           /* common lib funcs */
#include <string.h>           /* for strings management */
#include <fcntl.h>
#include <netdb.h>
#include <pthread.h>          /* for concurrent behavior */
#include <assert.h>           /* for using assertions */
#include <time.h>             /* for random number generation */
#include <wait.h>             /* for process sync */
#include <dirent.h>           /* for directory handling */

/* data types aliases */
#define SA struct sockaddr

#endif
